.386
.MODEL 	FLAT,STDCALL
option 	casemap:none
include	Trouble.inc

.code

Effect proc screenw,screenh,hdcS:DWORD
    LOCAL w :DWORD, h :DWORD, x :DWORD, y :DWORD, x1 :DWORD, y1 :DWORD

    mov eax, screenw           ; width
    sub eax, 3        
    invoke nrandom, eax
    add eax, 1
    mov w, eax

    mov eax, screenh           ; height
    sub eax, 3
    invoke nrandom, eax
    add eax, 1
    mov h, eax

    mov eax, screenw           ; top-left-x
    sub eax, 1
    sub eax, w
    invoke nrandom, eax
    add eax, 1
    mov x, eax

    mov eax, screenh           ; top-left-y
    sub eax, 2
    sub eax, h
    invoke nrandom, eax
    add eax, 1
    mov y, eax

    mov eax, 3                  ; destination top-left-x
    invoke nrandom, eax
    sub eax, 1
    add eax, x
    mov x1, eax

    mov eax, 3                  ; destination top-left-y
    invoke nrandom, eax
    neg eax
    add eax, y
    mov y1, eax

    invoke BitBlt,hdcS,x,y,w,h,hdcS,x1,y1,SRCCOPY      
    ret
Effect endp

TroubleThread PROC 
	LOCAL	count,screen_w,screen_h,hdcScreen:DWORD
	LOCAL 	rect:RECT
	
;	invoke GetClientRect,hWnd,addr rect	
	mov    hdcScreen,FUNC (GetDC, hWnd)
	mov count,0
	mov rect.bottom,100
	mov rect.right,300
	

	@@:
	inc count
	invoke   Effect,rect.right,rect.bottom,hdcScreen
	invoke Sleep, 5
	.if count == 1
		invoke InvalidateRect,hWnd,0,FALSE
		mov count,0
	.endif
	mov    eax,bStopping
	test   eax, eax
	jz     @B
	
	invoke ReleaseDC, 0,hdcScreen
	invoke EndDialog,hWnd,0
	ret
TroubleThread endp


start:
	mov hInstance,FUNC (GetModuleHandle, NULL)
	invoke DialogBoxParam,hInstance,1000,NULL,addr DlgProc,NULL
	invoke ExitProcess,0 
       
DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL idThread,hOld,memDC,hdc:DWORD
	LOCAL ps:PAINTSTRUCT
	LOCAL 	rect:RECT

	Switch uMsg
	Case WM_INITDIALOG
	m2m hWnd,hWin
	mov pBmp1,FUNC (BitmapFromResource,hInstance,101) 		
	invoke SendDlgItemMessage,hWin,1000,STM_SETIMAGE,IMAGE_BITMAP,pBmp1
	invoke CloseHandle,FUNC (CreateThread,0,0,addr TroubleThread,0,0,addr idThread)


	Case WM_PAINT	
		invoke GetWindowRect,hWin,addr rect
		mov hdc,FUNC (BeginPaint,hWin,addr ps)
		mov memDC,FUNC (CreateCompatibleDC,hdc)
		mov hOld,FUNC(SelectObject,memDC,pBmp1)
		invoke BitBlt,hdc,0,0,rect.right,rect.bottom,memDC,0,0,SRCCOPY
		invoke SelectObject,hdc,hOld
		invoke DeleteDC,memDC
		invoke EndPaint,hWin,addr ps
		return 0

	Case WM_CLOSE
		invoke DeleteObject,pBmp1
		mov    bStopping, 1
	Endsw
		return 0	
DlgProc endp

end start